# -*- coding: UTF-8 -*-
import re
import json

def get_tags():
    return ['2','2.3','2.3.1']

def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)

    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out

def run_audit(runcontext,ansible_params,module):
    redis_cli_cmd = runcontext.get_extra_var('REDIS_CLI_CMD')
    is_pass_version = runcontext.get_extra_var('REDIS_ISPAAS_VERSION')
    
    curtemplate = runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
   
    tmpCmd = redis_cli_cmd.strip()
    if tmpCmd.endswith('"'):
        tmpCmd = tmpCmd.rstrip('"')
        tmp_vars["scancommand1"] = '%s ping"' % tmpCmd 
    else:
        tmp_vars["scancommand1"] = '%s ping' % tmpCmd
    tmp_vars["systemvalue1"] = ""
    ret_code = -1
    
    if is_pass_version:
        tmp_vars["policyresult"] = "pass"
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["systemvalue1"] = "PaaS Redis"
        ret_code = 0
    else:
        runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
        arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
        runcontext.sleep()
        runcontext.log_debug_invoke_result(arc1,astdout1,astderr1)

        if arc1 != 0:
            return (-2, "Failed to invoke module: %s."%astdout1)
        resultjson1 = json.loads(astdout1)
        astdout1 = resultjson1["stdout"]
        astderr1 = resultjson1["stderr"]
        match1_found=re.match(r".*\s*NOAUTH Authentication required.", astdout1)
        
        tmp_vars["systemvalue1"] = astdout1
        
        if match1_found is not None:
            tmp_vars["checkresult1"] = "pass"
            
        if (tmp_vars["checkresult1"] == "pass"):
            tmp_vars["policyresult"]="pass"
            ret_code = 0

    rc,out=curtemplate.render(runcontext.get_template_file('r_2_3_1.j2'),**tmp_vars)

    if rc == False:
        return (-2,"failed to render template.%s" % out)

    return ret_code,out
